import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import processing.video.*; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class Clock_project extends PApplet {

/**
 * Frame Differencing 
 * by Golan Levin. 
 *
 * Quantify the amount of movement in the video frame using frame-differencing.
 */ 



int cx, cy;
float secondsRadius;
float minutesRadius;
float hoursRadius;
float clockDiameter;
int movementSum = 0;
int numPixels;
int[] previousFrame;
Capture video;

int moveseconds;
int moveminutes;

public void setup() {
   size(800, 800);
 // stroke(255);
  
  int radius = min(width, height) / 2;
  secondsRadius = radius * 0.72f;
  minutesRadius = radius * 0.60f;
  hoursRadius = radius * 0.50f;
  clockDiameter = radius * 1.8f;
  
  cx = width / 2;
  cy = height / 2;
  
  
  
  // This the default video input, see the GettingStartedCapture 
  // example if it creates an error
  video = new Capture(this, width, height);
  
  // Start capturing the images from the camera
  video.start(); 
  
  numPixels = 800 * 800;//video.width * video.height;
  // Create an array to store the previously captured frame
  previousFrame = new int[numPixels];
  loadPixels();


frame.setBackground( new java.awt.Color(0,0,0)); 





}




public void draw() {
 
  
  background(0); 

  loadPixels();
  
  
  
  
  if (video.available()) {
    // When using video to manipulate the screen, use video.available() and
    // video.read() inside the draw() method so that it's safe to draw to the screen
    video.read(); // Read the new frame from the camera
    video.loadPixels(); // Make its pixels[] array available
    
    movementSum = 0; // Amount of movement in the frame
    for (int i = 0; i < numPixels; i++) { // For each pixel in the video frame...
      int currColor = video.pixels[i];
      int prevColor = previousFrame[i];
      // Extract the red, green, and blue components from current pixel
      int currR = (currColor >> 16) & 0xFF; // Like red(), but faster
      int currG = (currColor >> 8) & 0xFF;
      int currB = currColor & 0xFF;
      // Extract red, green, and blue components from previous pixel
      int prevR = (prevColor >> 16) & 0xFF;
      int prevG = (prevColor >> 8) & 0xFF;
      int prevB = prevColor & 0xFF;
      // Compute the difference of the red, green, and blue values
      int diffR = abs(currR - prevR);
      int diffG = abs(currG - prevG);
      int diffB = abs(currB - prevB);
      // Add these differences to the running tally
      movementSum += diffR + diffG + diffB;
     
      // Render the difference image to the screen
   pixels[i] = color(diffR, diffG, diffB);
      // The following line is much faster, but more confusing to read
      //pixels[i] = 0xff000000 | (diffR << 16) | (diffG << 8) | diffB;
      // Save the current color into the 'previous' buffer
      previousFrame[i] = currColor;
    }
     moveseconds = PApplet.parseInt(map(movementSum, 150000, 11000000, 2, 6));
     moveminutes = PApplet.parseInt(map(movementSum, 15000000, 1100000000, 1, 3));
    // To prevent flicker from frames that are all black (no movement),
    // only update the screen if the image has changed.
    //if (movementSum > 0) {
     updatePixels();
      println(moveseconds); // Print the total amount of movement to the console
    //
  
}

// Draw the clock background

 // stroke(600);
  
  
  
  // Angles for sin() and cos() start at 3 o'clock;
  // subtract HALF_PI to make them start at the top
//float s=(map(movementSum + norm(second(),0,60)), 150000, 1100000, 1, 2));
 //float s = map(movementSum, 15000000, 110000000, 1, 2);
  float s = map(second()-moveseconds, 0, 60, 0, TWO_PI) - HALF_PI;
 
 //float s = map(second()+movementSum, 0, 60, 0, TWO_PI) - HALF_PI;
float m = map(minute() + norm(second(), 0, 60)+moveminutes, 0, 60, 0, TWO_PI) - HALF_PI; 
   //float m = map(movementSum, 15000000, 110000000, 1, 2);
  
  float h = map(hour() + norm(minute(), 0, 60), 0, 24, 0, TWO_PI * 2) - HALF_PI;
  
  // Draw the hands of the clock
  stroke(255, 255, 255);
  strokeWeight(3);
  line(cx, cy, cx + cos(s) * secondsRadius, cy + sin(s) * secondsRadius);
  strokeWeight(5);
  line(cx, cy, cx + cos(m) * minutesRadius, cy + sin(m) * minutesRadius);
  strokeWeight(9);
  line(cx, cy, cx + cos(h) * hoursRadius, cy + sin(h) * hoursRadius);
  
  // Draw the minute ticks
  strokeWeight(3);
  
  beginShape(POINTS);
  for (int a = 0; a < 360; a+=30) {
    float angle = radians(a);
    float x = cx + cos(angle) * secondsRadius;
    float y = cy + sin(angle) * secondsRadius;
    vertex(x, y);
  }
  endShape();


  }
  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "Clock_project" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
